'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _es = require('./presets/es');

var _es2 = _interopRequireDefault(_es);

var _react = require('./presets/react');

var _react2 = _interopRequireDefault(_react);

var _babelPluginTransformRuntime = require('babel-plugin-transform-runtime');

var _babelPluginTransformRuntime2 = _interopRequireDefault(_babelPluginTransformRuntime);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

var _pick2 = require('lodash/pick');

var _pick3 = _interopRequireDefault(_pick2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Type = _flowRuntime2.default.tdz(function () {
  return _flowRuntime.Type;
});

var PresetReactOpts = _flowRuntime2.default.tdz(function () {
  return _react.Opts;
});

var PresetESOpts = _flowRuntime2.default.tdz(function () {
  return _es.Opts;
});

var DEFAULT_OPTS = (0, _freeze2.default)((0, _assign2.default)({}, _es.DEFAULT_OPTS, _react.DEFAULT_OPTS, {
  react: true,
  babelRuntime: true
}));

var Opts = _flowRuntime2.default.type('Opts', _flowRuntime2.default.intersection(_flowRuntime2.default.ref(PresetESOpts), _flowRuntime2.default.ref(PresetReactOpts), _flowRuntime2.default.object(_flowRuntime2.default.property('react', _flowRuntime2.default.boolean()), _flowRuntime2.default.property('babelRuntime', _flowRuntime2.default.boolean()))));

exports.default = _flowRuntime2.default.annotate(function (context, opts) {
  var _contextType = _flowRuntime2.default.any();

  var _optsType = _flowRuntime2.default.nullable(_flowRuntime2.default.$shape(Opts));

  _flowRuntime2.default.param('context', _contextType).assert(context);

  _flowRuntime2.default.param('opts', _optsType, true).assert(opts);

  // eslint-disable-next-line no-use-before-define
  checkForUnknownOpts(opts, DEFAULT_OPTS);

  var options = (0, _assign2.default)({}, DEFAULT_OPTS, opts);

  var presetESOpts = (0, _pick3.default)(options, (0, _keys2.default)(_es.DEFAULT_OPTS));
  var presetReactOpts = (0, _pick3.default)(options, (0, _keys2.default)(_react.DEFAULT_OPTS));

  return {
    presets: [[_es2.default, presetESOpts], options.react ? [_react2.default, presetReactOpts] : null].filter(Boolean),

    plugins: [
    // to avoid duplicate babel helpers code
    options.babelRuntime ? _babelPluginTransformRuntime2.default : null].filter(Boolean)
  };
}, _flowRuntime2.default.function(_flowRuntime2.default.param('context', _flowRuntime2.default.any()), _flowRuntime2.default.param('opts', _flowRuntime2.default.nullable(_flowRuntime2.default.$shape(Opts)))));


function checkForUnknownOpts(opts, availableOpts) {
  var _optsType2 = _flowRuntime2.default.nullable(_flowRuntime2.default.object());

  var _availableOptsType = _flowRuntime2.default.object();

  _flowRuntime2.default.param('opts', _optsType2, true).assert(opts);

  _flowRuntime2.default.param('availableOpts', _availableOptsType).assert(availableOpts);

  if (!opts) {
    return;
  }
  // check unknown options
  (0, _keys2.default)(opts).forEach(function (opt) {
    if (!(opt in availableOpts)) {
      var optType = Opts;

      // missing
      throw new Error('unknown option passed \'' + opt + '\'' + '\nAvailable opts' + ('\n' + optType.unwrap().toString()));
    }
  });
}

_flowRuntime2.default.annotate(checkForUnknownOpts, _flowRuntime2.default.function(_flowRuntime2.default.param('opts', _flowRuntime2.default.nullable(_flowRuntime2.default.object())), _flowRuntime2.default.param('availableOpts', _flowRuntime2.default.object())));