'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFAULT_OPTS = exports.Opts = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _babelPresetEnv = require('babel-preset-env');

var _babelPresetEnv2 = _interopRequireDefault(_babelPresetEnv);

var _babelPluginTransformDecoratorsLegacy = require('babel-plugin-transform-decorators-legacy');

var _babelPluginTransformDecoratorsLegacy2 = _interopRequireDefault(_babelPluginTransformDecoratorsLegacy);

var _babelPluginTransformDecorators = require('babel-plugin-transform-decorators');

var _babelPluginTransformDecorators2 = _interopRequireDefault(_babelPluginTransformDecorators);

var _babelPluginTransformClassProperties = require('babel-plugin-transform-class-properties');

var _babelPluginTransformClassProperties2 = _interopRequireDefault(_babelPluginTransformClassProperties);

var _babelPluginTransformObjectRestSpread = require('babel-plugin-transform-object-rest-spread');

var _babelPluginTransformObjectRestSpread2 = _interopRequireDefault(_babelPluginTransformObjectRestSpread);

var _babelPluginTransformFlowStripTypes = require('babel-plugin-transform-flow-strip-types');

var _babelPluginTransformFlowStripTypes2 = _interopRequireDefault(_babelPluginTransformFlowStripTypes);

var _babelPluginSyntaxFlow = require('babel-plugin-syntax-flow');

var _babelPluginSyntaxFlow2 = _interopRequireDefault(_babelPluginSyntaxFlow);

var _babelPluginSyntaxDynamicImport = require('babel-plugin-syntax-dynamic-import');

var _babelPluginSyntaxDynamicImport2 = _interopRequireDefault(_babelPluginSyntaxDynamicImport);

var _transformFlowStripTypesImportFix = require('../plugins/transform-flow-strip-types-import-fix');

var _transformFlowStripTypesImportFix2 = _interopRequireDefault(_transformFlowStripTypesImportFix);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Opts = exports.Opts = _flowRuntime2.default.type('Opts', _flowRuntime2.default.object(_flowRuntime2.default.property('flow', _flowRuntime2.default.boolean()), _flowRuntime2.default.property('asyncAwait', _flowRuntime2.default.boolean()), _flowRuntime2.default.property('dynamicImport', _flowRuntime2.default.boolean()), _flowRuntime2.default.property('modules', _flowRuntime2.default.union(_flowRuntime2.default.string('amd'), _flowRuntime2.default.string('umd'), _flowRuntime2.default.string('systemjs'), _flowRuntime2.default.string('commonjs'), _flowRuntime2.default.boolean(false))), _flowRuntime2.default.property('targets', _flowRuntime2.default.object()), _flowRuntime2.default.property('decorators', _flowRuntime2.default.boolean()), _flowRuntime2.default.property('useBuiltIns', _flowRuntime2.default.boolean()), _flowRuntime2.default.property('debug', _flowRuntime2.default.boolean())));

var DEFAULT_OPTS = exports.DEFAULT_OPTS = Opts.assert((0, _freeze2.default)({
  flow: true,
  asyncAwait: false,
  dynamicImport: false,
  modules: 'commonjs',
  targets: {},
  decorators: false,
  useBuiltIns: true,
  debug: false
}));

exports.default = _flowRuntime2.default.annotate(function (context, opts) {
  var _contextType = _flowRuntime2.default.any();

  var _optsType = Opts;

  _flowRuntime2.default.param('context', _contextType).assert(context);

  _flowRuntime2.default.param('opts', _optsType).assert(opts);

  var targets = opts.targets,
      modules = opts.modules,
      debug = opts.debug,
      useBuiltIns = opts.useBuiltIns;


  return {
    presets: [[_babelPresetEnv2.default, {
      targets: targets,
      modules: modules,
      debug: debug,
      useBuiltIns: useBuiltIns,
      // only enable generator when asyncAwait enabled
      exclude: !opts.asyncAwait // eslint-disable-line no-negated-condition
      ? ['transform-regenerator', 'transform-async-to-generator'] : []
    }]],

    plugins: [opts.dynamicImport ? _babelPluginSyntaxDynamicImport2.default : null].concat((0, _toConsumableArray3.default)(opts.decorators ? [_babelPluginTransformDecoratorsLegacy2.default, _babelPluginTransformDecorators2.default] : []), [_babelPluginTransformClassProperties2.default, [_babelPluginTransformObjectRestSpread2.default, { useBuiltIns: true }]], (0, _toConsumableArray3.default)(opts.flow ? [_transformFlowStripTypesImportFix2.default, _babelPluginTransformFlowStripTypes2.default, _babelPluginSyntaxFlow2.default] : [])).filter(Boolean)
  };
}, _flowRuntime2.default.function(_flowRuntime2.default.param('context', _flowRuntime2.default.any()), _flowRuntime2.default.param('opts', Opts)));